﻿@model StarterProjectV2.ViewModels.OwnerChatView
@section PAGETITLE{
    Chat Details
}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />

    <title>Tuts+ Chat Application</title>
    <meta name="description" content="Tuts+ Chat Application" />
    <link rel="stylesheet" href="style.css" />
    <!-- Font -->
    <link rel="preconnect" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css2?family=Roboto:wght@300&display=swap" rel="stylesheet">
    <script src="~/Content/vendors/js/jquery.min.js"></script>
    <style>
        * {
            margin: 0;
            padding: 0;
        }

        body {
            font-family: 'Roboto', sans-serif;
            margin: 20px auto;
            font-family: "Lato";
            font-weight: 300;
        }

        form {
            padding: 15px 25px;
            display: flex;
            gap: 10px;
            justify-content: center;
        }

            form label {
                font-size: 1.5rem;
                font-weight: bold;
            }

        input {
            font-family: "Lato";
        }

        a {
            color: #0000ff;
            text-decoration: none;
        }

            a:hover {
                text-decoration: underline;
            }

        #wrapper {
            border-bottom: 5px solid #f0f0f0;
        }

        #wrapper,
        #loginform {
            font-family: 'Roboto', sans-serif;
            margin: 0 auto;
            padding-bottom: 25px;
            background-color: #f0f0f0;
            width: 600px;
            max-width: 100%;
            overflow: auto;
            box-shadow: 0px 5px 10px rgba(0,0,0,0.3);
        }

        #loginform {
            padding-top: 18px;
            text-align: center;
        }

            #loginform p {
                padding: 15px 25px;
                font-size: 1.4rem;
                font-weight: bold;
            }

        #chatbox {
            text-align: left;
            margin: 15px auto;
            margin-bottom: 25px;
            padding: 10px;
            background: #fff;
            height: 300px;
            width: 530px;
            max-width: 100%;
            border: 1px solid #a7a7a7;
            overflow: auto;
            border-radius: 4px;
            border-bottom: 4px solid #a7a7a7;
        }

        #usermsg {
            flex: 1;
            border-radius: 4px;
            border: 1px solid #c5d5c5;
            /* #ff9800 */
        }

        #name {
            border-radius: 4px;
            border: 1px solid #ff9800;
            padding: 2px 8px;
        }

        #submitmsg,
        #enter {
            background: #9fa9a3;
            border: 2px solid #9fa9a3;
            color: white;
            padding: 4px 10px;
            font-weight: bold;
            border-radius: 4px;
        }

        .error {
            color: #ff0000;
        }

        #menu {
            background: #c5d5c5;
            /* background-color: rgba(238, 238, 238, 1); */
            padding: 15px 20px 0px 20px;
            display: flex;
            border-bottom: 1px solid #ccc;
        }

            #menu p.welcome {
                flex: 1;
            }

        a#exit {
            color: white;
            background: #9fa9a3;
            padding: 4px 8px;
            border-radius: 4px;
            font-weight: bold;
        }

        .msgln {
            margin: 0 0 5px 0;
        }

            .msgln span.left-info {
                color: orangered;
                color: #ffe
            }

            .msgln span.chat-time {
                color: #666;
                font-size: 60%;
                vertical-align: super;
            }

            .msgln b.user-name, .msgln b.user-name-left {
                font-weight: bold;
                background: #546e7a;
                color: white;
                padding: 2px 4px;
                font-size: 90%;
                border-radius: 4px;
                margin: 0 5px 0 0;
            }

            .msgln b.user-name-left {
                background: orangered;
            }

        .chat-box-bubble {
            margin: 5px;
            padding: 5px;
            border-radius: 2px;
            width: 100%;
        }

        .chat-box-content-you {
            font-size: 15px;
            text-align: right;
            border-radius: 12px;
            margin: 0;
            padding: 10px;
            color: black;
            background: rgba(197, 213, 197, 0.2);
        }

        .chat-box-content {
            font-size: 15px;
            border-radius: 12px;
            margin: 0;
            padding: 10px;
            color: black;
            background: rgba(197, 213, 197, 0.6);
        }

        .chat-box-name {
            /* flex: 1; */
            padding: 0;
            font-size: 15px;
            font-weight: bold;
            color: #6b6e6c;
            transition: .1s ease-out;
            margin-bottom: 8px;
        }

        .chat-box-text {
            padding: 5px;
            margin-bottom: 0px;
        }

        .chat-box-time {
            padding: 5px;
            margin-bottom: 5px;
            font-size: 10px;
        }
    </style>
</head>
<body style=" background-color: oldlace">
    <div id="wrapper">
        <div id="menu">
            <p class="welcome">Chat with @Model.SlotId<b></b></p>
            <p class="logout"><a id="exit" href="/OwnerChat/ChatManagement">Exit Chat</a></p>
        </div>
        <div id="chatbox">
            @if (@Model.Chats != null)
            {
            foreach (var chat in Model.Chats)
            {
                <div class="chat-box-bubble row">
                    @if (chat.SlotId == chat.Sender)
                    {
                    <div class='col-md-9 col-xs-9'>
                        <div class="d-flex justify-content-start">
                            <p class="chat-box-name mr-1">@chat.Sender</p>
                        </div>
                        <div class="chat-box-content">
                            <p class="chat-box-text">@chat.Text</p>
                            @*<p class="chat-box-time">@chat.DeliveryTime.ToString("d/M/yyyy hh:mm:tt")</p>*@
                            <p class="chat-box-time">@chat.DeliveryTime.ToString("d/M/yyyy hh:mm:ss")</p>
                        </div>
                    </div>
                    }
                    else
                    {
                    <div class='col-md-3 col-xs-3'></div>
                    <div class='col-md-9 col-xs-9'>
                        <div class="d-flex justify-content-end">
                            <p class="chat-box-name mr-1">Admin</p>
                        </div>
                        <div class="chat-box-content-you">
                            <p class="chat-box-text">@chat.Text</p>
                            @*<p class="chat-box-time">@chat.DeliveryTime.ToString("d/M/yyyy hh:mm:tt")</p>*@
                            <p class="chat-box-time">@chat.DeliveryTime.ToString("d/M/yyyy hh:mm:ss")</p>
                        </div>
                    </div>
                    <div class='col-md-3 col-xs-3'></div>
                    }

                </div>
            }
            }
        </div>

        <form name="message" action="">
            <textarea id="usermsg" name="usermsg" type="text" rows="1" cols="50"></textarea>
            <!-- <input name="usermsg" type="text" id="usermsg" /> -->
            <input name="submitmsg" type="submit" id="submitmsg" value="Send" />
        </form>

        <form name="message" action="">
            @*type="submit"*@
            <input name="getPrevMsg" type="button" id="getPrevMsg" value="Prev Message" />
        </form>
    </div>
    <script src="~/Content/vendors/js/jquery.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

    <script>
        var canScrollUpForData = true;
        var lastId = 0; //1, 6
        var latestId = 0; //5, 7
        var chats;

        //Testing the JSON
    $(document).ready(function () {
        var chats2 = @Html.Raw(Json.Encode(Model.Chats));
        //alert("Chats Length: " + chats2.length);
        @*lastId = "@Model.Chats.ElementAt(0).ID";
        latestId="@Model.Chats.ElementAt(4).ID";*@
        try {
            lastId = chats2[0].ID;
            //alert("lastId: " + lastId);
        } catch (err) {
            //alert("error");
            lastId = 0;
        }
        try {
            latestId = chats2[chats2.length - 1].ID;
            //alert("Last CHat ID : " + chats2[chats2.length - 1].ID);
            //alert("In try: " + latestId);
            //alert("Latest Id " + latestId);
        } catch (err) {
            //alert("Error2");
            //alert("In before catch : " + latestId);
            latestId = 0;
        }
        //console.log(lastId);
        //console.log(latestId);

        var clientmsg = $("#usermsg").val();

        });
        // jQuery Document
        //$(document).ready(function () { });

        //Making scroll bar stay at bottom
        $('#chatbox').scrollTop($('#chatbox')[0].scrollHeight);

        //If user submits the form
        $("#submitmsg").click(function () {
            var clientmsg = $("#usermsg").val();
            //ajax
            //alert(clientmsg);
            var model = {
                CurrentMessage: clientmsg,
                SlotId : "@Model.SlotId"
            }
            $.ajax({
                context: this,
                type: 'post',
                url: '../OwnerChat/addMessage',
                data: model,
                success: function (result) {
                    //alert("success");
                    //Update the Chat Screen
                    //location.reload(); //Page Reload
                },
                error: function () {
                    //error();
                }
            });

            @*$.post("post.php", { text: clientmsg });*@

            $("#usermsg").val("");
            return false;
        });

        function prependPrevMessages(chats) {

            for (chat of chats) {

                var div1 = document.createElement('div');
                div1.classList.add("chat-box-bubble");
                div1.classList.add("row");

                var div2 = document.createElement('div');
                div2.classList.add("col-md-3");
                div2.classList.add("col-xs-3");

                var div3 = document.createElement('div');
                div3.classList.add("col-md-9");
                div3.classList.add("col-xs-9");

                var div4 = document.createElement('div');
                var p1 = document.createElement('p');
                div4.classList.add("d-flex");
                p1.classList.add("chat-box-name");
                if (chat.SlotId != chat.Sender) {
                    div4.classList.add("justify-content-end");
                    p1.classList.add("mr-1");
                }
                else {
                    div4.classList.add("justify-content-start");
                }
                p1.appendChild(document.createTextNode(chat.Sender));
                div4.appendChild(p1)

                var div5 = document.createElement('div');
                if (chat.SlotId != chat.Sender) {
                    div5.classList.add("chat-box-content-you");
                }
                else {
                    div5.classList.add("chat-box-content");
                }
                var p2 = document.createElement('p');
                p2.classList.add("chat-box-text");
                p2.appendChild(document.createTextNode(chat.Text));
                //var dateInMilisecond = chat.DeliveryTime;
                var dt = new Date(parseInt((chat.DeliveryTime).replace('/Date(', '')));
                var time = dt.toString().split(' ')[4]
                var deliveryTime = `${String(dt.getDate())}-${String(dt.getMonth() + 1)}-${String(dt.getFullYear())} ${time}`


                var p3 = document.createElement('p');
                p3.classList.add("chat-box-time");
                p3.appendChild(document.createTextNode(deliveryTime));
                div5.appendChild(p2);
                div5.appendChild(p3);

                div3.appendChild(div4);
                div3.appendChild(div5);

                if (chat.SlotId != chat.Sender) {
                    div1.appendChild(div2);
                    div1.appendChild(div3);
                }
                else {
                    div1.appendChild(div3);
                    div1.appendChild(div2);
                }

                $("#chatbox").prepend(div1)
            }

        }

        function appendNewMessages(chats) {

            for (chat of chats) {

                var div1 = document.createElement('div');
                div1.classList.add("chat-box-bubble");
                div1.classList.add("row");

                var div2 = document.createElement('div');
                div2.classList.add("col-md-3");
                div2.classList.add("col-xs-3");

                var div3 = document.createElement('div');
                div3.classList.add("col-md-9");
                div3.classList.add("col-xs-9");

                var div4 = document.createElement('div');
                var p1 = document.createElement('p');
                div4.classList.add("d-flex");
                p1.classList.add("chat-box-name");
                if (chat.SlotId != chat.Sender) {
                    div4.classList.add("justify-content-end");
                    p1.classList.add("mr-1");
                }
                else {
                    div4.classList.add("justify-content-start");
                }
                p1.appendChild(document.createTextNode(chat.Sender));
                div4.appendChild(p1)

                var div5 = document.createElement('div');
                if (chat.SlotId != chat.Sender) {
                    div5.classList.add("chat-box-content-you");
                }
                else {
                    div5.classList.add("chat-box-content");
                }

                var p2 = document.createElement('p');
                p2.classList.add("chat-box-text");
                p2.appendChild(document.createTextNode(chat.Text));

                var p3 = document.createElement('p');
                p3.classList.add("chat-box-time");
                //var dateInMilisecond = chat.DeliveryTime;
                var dt = new Date(parseInt((chat.DeliveryTime).replace('/Date(', '')));
                var time = dt.toString().split(' ')[4]
                var deliveryTime = `${String(dt.getDate())}-${String(dt.getMonth() + 1)}-${String(dt.getFullYear())} ${time}`
                p3.appendChild(document.createTextNode(deliveryTime));
                div5.appendChild(p2);
                div5.appendChild(p3);

                div3.appendChild(div4);
                div3.appendChild(div5);

                if (chat.SlotId != chat.Sender) {
                    div1.appendChild(div2);
                    div1.appendChild(div3);
                }
                else {
                    div1.appendChild(div3);
                    div1.appendChild(div2);
                }

                $("#chatbox").append(div1)
            }
            $('#chatbox').scrollTop($('#chatbox')[0].scrollHeight);

        }

        //Getting previous message
        $("#getPrevMsg").click(function () {
            $.ajax({
                context: this,
                type: 'post',
                url: '../OwnerChat/gettingChatWithAdmin?slotId=' + '@Model.SlotId' + '&lastId=' + lastId,
                success: function (result) {
                    console.log(result.chatList)
                    chats = result.chatList;
                    lastId = result.LastID
                    console.log("last id : " + result.LastID)
                    console.log(chats)
                    if (chats) {
                        prependPrevMessages(chats)
                        $('#chatbox').scrollTop(400);
                    }

                },
                error: function () {
                    //alert("Error");
                }
            });

        });

        $('#chatbox').scroll(function () {
            if ($('#chatbox').scrollTop() == $('#chatbox').height() - $('#chatbox').height()) {
                console.log("TOP");
                if (canScrollUpForData) {
                    $.ajax({
                        context: this,
                        type: 'post',
                        url: '../OwnerChat/gettingChatWithAdmin?slotId=' + '@Model.SlotId' + '&lastId=' + lastId,
                        success: function (result) {
                            console.log(result.chatList)
                            chats = result.chatList;
                            lastId = result.LastID
                            console.log("last id : " + result.LastID)
                            console.log(chats)
                            if (chats) {
                                prependPrevMessages(chats)
                                $('#chatbox').scrollTop(400);
                            }
                            else {
                                //alert("No more");
                                canScrollUpForData = false;
                            }

                        },
                        error: function () {
                            //alert("Error: No more Data");
                        }
                    });
                }

            }
        });

        setInterval(function () {
            $.ajax({
                context: this,
                type: 'post',
                url: '../OwnerChat/gettingNewMessages?slotId=' + '@Model.SlotId' + '&latestId=' + latestId,
                success: function (result) {
                    chats = result.chatList;
                    //alert("Result Latest ID: " + result.LatestID);
                    latestId = result.LatestID
                    //alert("LatestId: " + latestId);
                    console.log("latest ID : " + result.latestId);
                    console.log(chats.length);

                    if (chats.length!==0) {
                        appendNewMessages(chats)
                    }
                },
                error: function () {
                    //alert("Error");
                }
            });
        }, 2000);

         $("#newItem").remove();

        $("#editItem").remove();
        $("#saveItem").remove();
        $("#deleteItem").remove();

        $('#printItem').remove();

        $('#reloadItem').remove();

        $("#dashboardItem").remove();
        $("#reportItem").remove();
    </script>
</body>
</html>
